<?php

namespace ShineSoftware\Setefi\Block\Hosted;

class Redirect extends \Magento\Framework\View\Element\Template {

    protected $_orderFactory;
    protected $_checkoutSession;

    public function __construct(
    \Magento\Framework\View\Element\Template\Context $context, \Magento\Sales\Model\OrderFactory $orderFactory, \Magento\Checkout\Model\Session $checkoutSession
    ) {
        $this->_orderFactory = $orderFactory;
        $this->_checkoutSession = $checkoutSession;
        parent::__construct($context);
    }

    public function __($content) {
        return __($content);
    }

    public function getSecureUrl() {
        if (!$this->_checkoutSession->getLastRealOrder()->getId()) {
            return false;
        }
        $data = $this->_checkoutSession->getLastRealOrder()->getPayment()->getAdditionalInformation();
        if (empty($data['init']['hostedpageurl']) && empty($data['hostedpageurl'])) {
            return false;
        }
        
        $hostedpageurl = isset($data['init']['hostedpageurl']) ? $data['init']['hostedpageurl'] : $data['hostedpageurl'];
        unset($data['init']['hostedpageurl']);
        unset($data['hostedpageurl']);
        $this->_checkoutSession->getLastRealOrder()->getPayment()->setAdditionalInformation($data)->save();
        return $hostedpageurl;
    }

}

;
